               HEAD
     ******************************************************************
     *  LINCOLN'S BIRTHDAY PROGRAM
     *      BY RONALD MAK
     *
     *  ORIGINAL VERSION: FEBRUARY 1969
     *  RESURRECTED:      FEBRUARY 2005
     ******************************************************************
     *
     * LINCOLN'S GETTYSBURG ADDRESS
     *
     IDENT     DCW  @LINCOLN PROGREM REVISION 1.1 ASSEMBLED 03/07/2015@
     GETTYS    DCW  0
               DC   @FOURSCOREANDSEVENYEARSAGOOURFATHERSBROU@
               DC   @GHTFORTHONTHISCONTINENTANEWNATIONCONCEI@
               DC   @VEDINLIBERTYANDDEDICATEDTOTHEPROPOSITIO@
               DC   @NTHATALLMENARECREATEDEQUALNOWWEAREENGAG@
               DC   @EDINAGREATCIVILWARTESTINGWHETHERTHATNAT@
               DC   @IONORANYNATIONSOCONCEIVEDANDSODEDICATED@
               DC   @CANLONGENDUREWEAREMETONAGREATBATTLEFIEL@
               DC   @DOFTHATWARWEHAVECOMETODEDICATEAPORTIONO@
               DC   @FTHATFIELDASAFINALRESTINGPLACEFORTHOSEW@
               DC   @HOHEREGAVETHEIRLIVESTHATTHATNATIONMIGHT@
               DC   @LIVEITISALTOGETHERFITTINGANDPROPERTHATW@
               DC   @ESHOULDDOTHISBUTINALARGERSENSEWECANNOTH@
               DC   @ALLOWTHISGROUNDTHEBRAVEMENLIVINGANDDEAD@
               DC   @WHOSTRUGGLEDHEREHAVECONSECRATEDITFARABO@
               DC   @VEOURPOORPOWERTOADDORDETRACTTHEWORLDWIL@
               DC   @LLITTLENOTENORLONGREMEMBERWHATWESAYHERE@
               DC   @BUTITCANNEVERFORGETWHATTHEYDIDHEREITISF@
               DC   @ORUSTHELIVINGRATHERTOBEDEDICATEDHERETOT@
               DC   @HEUNFINISHEDWORKWHICHTHEYWHOFOUGHTHEREH@
               DC   @AVETHUSFARSONOBLYADVANCEDITISRATHERFORU@
               DC   @STOBEHEREDEDICATEDTOTHEGREATTASKREMAINI@
               DC   @NGBEFOREUSTHATFROMTHESEHONOREDDEADWETAK@
               DC   @EINCREASEDDEVOTIONTOTHATCAUSEFORWHICHTH@
               DC   @EYGAVETHELASTFULLMEASUREOFDEVOTIONTHATW@
               DC   @EHEREHIGHLYRESOLVETHATTHESEDEADSHALLNOT@
               DC   @HAVEDIEDINVAINTHATTHISNATIONUNDERGODSHA@
               DC   @LLHAVEANEWBIRTHOFFREEDOMANDTHATGOVERNME@
               DC   @NTOFTHEPEOPLEBYTHEPEOPLEFORTHEPEOPLESHA@
               DC   @LNOTPERISHFROMTHISEARTH@
               DC   @
     *
     * PROGRAM START.  SET INDEX REGISTER X1 TO POINT TO THE
     * FIRST PRINT MAP VALUE, AND INDEX REGISTER X2 TO POINT
     * TO THE FIRST CHARACTER OF THE GETTYSBURG ADDRESS.
     * INDEX REGISTER X3 WILL LATER POINT INTO THE PRINT AREA.
     *
     START     MCW  IDENT,180
               SBR  X1,MAP&2            *POINT X1 TO PRINT MAP
               SBR  X2,GETTYS&1         *POINT X2 TO GETTYSBURG ADDRESS
     *
     * LOOP ONCE PER PRINT MAP VALUE.  FIRST CHECK IF IT'S THE
     * END OF THE PRINT MAP.  IF THE MAP VALUE IS NEGATIVE, THEN
     * PRINT OUT THE CURRENT LINE AND START A NEW ONE.
     *
     LOOP      MCW  0&X1,MAPVAL         *MAPVAL = CURENT MAP VALUE
               SBR  X1,2&X1             *POINT X1 TO THE NEXT VALUE
               C    @99@,MAPVAL         *IF MAPVAL = 99
               BE   DONE                *    THEN DONE
     *
               C    MAPVAL,@00@         *IF 0, THEN PRINT
               BU   TEST                *GO ON, ELSE
               W                        *   PRINT OUT CURRENT LINE
               CS   299                 *    CLEAR THE PRINT AREA
               SBR  X3,200              *    POINT X3 TO PRINT AREA
               B    LOOP
     *
     * EACH LINE ALTERNATES BETWEEN 'SKIP' AND 'TAKE'.
     *
     TEST      BCE  DOSKIP,NEXTDO,0     IF 'SKIP' THEN DO SKIP
     *
     * DO 'TAKE': TAKE MAPVAL NUMBER OF LETTERS FROM THE GETTYSBURG
     *            ADDRESS AND APPEND THEM TO THE CURRENT PRINT LINE.
     *
     DOTAKE    MN   0&X2,0&X3           *APPEND LETTER TO PRINT LINE
               MZ   0&X2,0&X3
               S    @1@,MAPVAL          *MAPVAL = MAPVAL - 1
               SBR  X3,1&X3             *POINT X3 TO NEXT PRINT POSITION
     *
     NEXTCH    SBR  X2,1&X2             *POINT X2 TO NEXT GETTYSBURG CHAR
               C    &00,MAPVAL          *IF MAPVAL > 0
               BH   DOTAKE              *   THEN TAKE SOME MORE CHARS
               MCW  SKIP,NEXTDO         *   ELSE NEXT DO 'SKIP'
               B    LOOP
     *
     * DO 'SKIP': SKIP MAPVAL NUMBER OF BLANKS IN THE PRINT LINE.
     *
     DOSKIP    A    MAPVAL,X3           *X3 = X3 + MAPVAL
               MCW  TAKE,NEXTDO         *NEXT DO 'TAKE'
               B    LOOP
     *
     * DONE WITH ALL PRINT MAP VALUES.  *PRINT THE FINAL LINE AND QUIT.
     *
     DONE      W
               CC   1                   *END OF FORM          
               EXIT
     ************************************************************
     *
     SKIP      DCW  0                   *'SKIP' CODE
     TAKE      DCW  1                   *'TAKE' CODE
     NEXTDO    DCW  0                   *WHAT TO DO NEXT IN THE LINE
     MAPVAL    DCW  00                  *PRINT MAP VALUE
     *
     * THE PRINT MAP.  A NEGATIVE NUMBER DENOTES THE START OF A NEW
     * LINE, AND ITS ABSOLUTE VALUE BECOMES THE INITIAL 'SKIP' VALUE.
     * EACH LINE'S MAP VALUES ALTERNATE BETWEEN 'SKIP' AND 'TAKE'
     * VALUES.  THE FINAL ZERO DENOTES THE END OF THE PRINT MAP.
     * MAP VALUES MUST EACH BE TWO DIGITS IN LENGTH.
     *
     MAP       DC   0
               DC   @004317003428003133002937002839002712062@
               DC   @300261010230026081718002607211600250920@
               DC   @100106002509211001050024102603040500221@
               DC   @333040021040208080422030020030506051020@
               DC   @040017040805040506010709030400170308050@
               DC   @404140502050205001803070409020104010105@
               DC   @010504030700180307030901020501010603030@
               DC   @301090018030702110102020201080101020202@
               DC   @020700180308022601090600190307032501100@
               DC   @100190406032601090100201225011001002111@
               DC   @170306010901002210150208010901002507070@
               DC   @104020201080207010026070604050902010501@
               DC   @002608050112010601040100260805010601020@
               DC   @102020701010100270705010317020100270515@
               DC   @110401002708260200281517040028370028360@
               DC   @028360027010134002601033300250106300025@
               DC   @010827002401112104010021041416070100120@
               DC   @626071201001005490100060455010003036001@
               DC   @004001140100361004100034280036100509004@
               DC   @00114010099@
     *
               END  START
