               JOB  Lincoln's Birthday Program
               CTL  3311
     ******************************************************************
     *  Lincoln's Birthday Program
     *      by Ronald Mak
     *
     *  Original version: February 1969
     *  Resurrected:      February 2005
     ******************************************************************
               ORG  87
     X1        DSA  0                  index register 1
               ORG  92
     X2        DSA  0                  index register 2
               ORG  97
     X3        DSA  0                  index register 3
     *
               ORG  333
     *
     * Lincoln's Gettysburg Address
     *
     GETTYS    DCW  0
               DC   @FOURSCOREANDSEVENYEARSAGOOURFATHERSBROU@
               DC   @GHTFORTHONTHISCONTINENTANEWNATIONCONCEI@
               DC   @VEDINLIBERTYANDDEDICATEDTOTHEPROPOSITIO@
               DC   @NTHATALLMENARECREATEDEQUALNOWWEAREENGAG@
               DC   @EDINAGREATCIVILWARTESTINGWHETHERTHATNAT@
               DC   @IONORANYNATIONSOCONCEIVEDANDSODEDICATED@
               DC   @CANLONGENDUREWEAREMETONAGREATBATTLEFIEL@
               DC   @DOFTHATWARWEHAVECOMETODEDICATEAPORTIONO@
               DC   @FTHATFIELDASAFINALRESTINGPLACEFORTHOSEW@
               DC   @HOHEREGAVETHEIRLIVESTHATTHATNATIONMIGHT@
               DC   @LIVEITISALTOGETHERFITTINGANDPROPERTHATW@
               DC   @ESHOULDDOTHISBUTINALARGERSENSEWECANNOTH@
               DC   @ALLOWTHISGROUNDTHEBRAVEMENLIVINGANDDEAD@
               DC   @WHOSTRUGGLEDHEREHAVECONSECRATEDITFARABO@
               DC   @VEOURPOORPOWERTOADDORDETRACTTHEWORLDWIL@
               DC   @LLITTLENOTENORLONGREMEMBERWHATWESAYHERE@
               DC   @BUTITCANNEVERFORGETWHATTHEYDIDHEREITISF@
               DC   @ORUSTHELIVINGRATHERTOBEDEDICATEDHERETOT@
               DC   @HEUNFINISHEDWORKWHICHTHEYWHOFOUGHTHEREH@
               DC   @AVETHUSFARSONOBLYADVANCEDITISRATHERFORU@
               DC   @STOBEHEREDEDICATEDTOTHEGREATTASKREMAINI@
               DC   @NGBEFOREUSTHATFROMTHESEHONOREDDEADWETAK@
               DC   @EINCREASEDDEVOTIONTOTHATCAUSEFORWHICHTH@
               DC   @EYGAVETHELASTFULLMEASUREOFDEVOTIONTHATW@
               DC   @EHEREHIGHLYRESOLVETHATTHESEDEADSHALLNOT@
               DC   @HAVEDIEDINVAINTHATTHISNATIONUNDERGODSHA@
               DC   @LLHAVEANEWBIRTHOFFREEDOMANDTHATGOVERNME@
               DC   @NTOFTHEPEOPLEBYTHEPEOPLEFORTHEPEOPLESHA@
               DC   @LNOTPERISHFROMTHISEARTH@
               DC   @
     *
     * Program start.  Set index register X1 to point to the
     * first print map value, and index register X2 to point
     * to the first character of the Gettysburg Address.
     * Index register X3 will later point into the print area.
     *
     START     SBR  X1,MAP&2              point X1 to print map
               SBR  X2,GETTYS&1         point X2 to Gettysburg address
     *
     * Loop once per print map value.  First check if it's the
     * end of the print map.  If the map value is negative, then
     * print out the current line and start a new one.
     *
     LOOP      MCW  0&X1,MAPVAL         MAPVAL = curent map value
               SBR  X1,2&X1             point X1 to the next value
               C    @99@,MAPVAL         if MAPVAL = 99
               BE   DONE                    then DONE
     *
               C    MAPVAL,@00@         IF 0, THEN PRINT
               BU   TEST                GO ON, ELSE
               W                            print out current line
               CS   299                     clear the print area
               SBR  X3,200                  point X3 to print area
               B    LOOP
     *
     * Each line alternates between 'skip' and 'take'.
     *
     TEST      BCE  DOSKIP,NEXTDO,0     if 'skip' then do skip
     *
     * Do 'take': Take MAPVAL number of letters from the Gettysburg
     *            Address and append them to the current print line.
     *
     DOTAKE    MN   0&X2,0&X3           append letter to print line
               MZ   0&X2,0&X3
               S    @1@,MAPVAL          MAPVAL = MAPVAL - 1
               SBR  X3,1&X3             point X3 to next print position
     *
     NEXTCH    SBR  X2,1&X2             point X2 to next Gettysburg char
               C    &00,MAPVAL          if MAPVAL > 0
               BH   DOTAKE                  then take some more chars
               MCW  SKIP,NEXTDO             else next do 'skip'
               B    LOOP
     *
     * Do 'skip': Skip MAPVAL number of blanks in the print line.
     *
     DOSKIP    A    MAPVAL,X3           X3 = X3 + MAPVAL
               MCW  TAKE,NEXTDO         next do 'take'
               B    LOOP
     *
     * Done with all print map values.  Print the final line and quit.
     *
     DONE      W
     FINIS     H    FINIS
               H
     *
     SKIP      DCW  0                   'skip' code
     TAKE      DCW  1                   'take' code
     NEXTDO    DCW  0                   what to do next in the line
     MAPVAL    DCW  00                  print map value
     *
     * The print map.  A negative number denotes the start of a new
     * line, and its absolute value becomes the initial 'skip' value.
     * Each line's map values alternate between 'skip' and 'take'
     * values.  The final zero denotes the end of the print map.
     * Map values must each be two digits in length.
     *
     MAP       DC   0
               DC   @004317003428003133002937002839002712062@
               DC   @300261010230026081718002607211600250920@
               DC   @100106002509211001050024102603040500221@
               DC   @333040021040208080422030020030506051020@
               DC   @040017040805040506010709030400170308050@
               DC   @404140502050205001803070409020104010105@
               DC   @010504030700180307030901020501010603030@
               DC   @301090018030702110102020201080101020202@
               DC   @020700180308022601090600190307032501100@
               DC   @100190406032601090100201225011001002111@
               DC   @170306010901002210150208010901002507070@
               DC   @104020201080207010026070604050902010501@
               DC   @002608050112010601040100260805010601020@
               DC   @102020701010100270705010317020100270515@
               DC   @110401002708260200281517040028370028360@
               DC   @028360027010134002601033300250106300025@
               DC   @010827002401112104010021041416070100120@
               DC   @626071201001005490100060455010003036001@
               DC   @004001140100361004100034280036100509004@
               DC   @00114010099@
     *
               END  START
