     ***************************************************************************
     *     SSSSS = CARD SEQUENCE NUMBER          ********** = LABEL
     *     OPER- = OPERATION                     OPERATION--- = OPERATION
SSSSS**********OPER-OPERANDS----------------------------------------------------     
     **********|****|***********************************************************
               JOB  COMPUTE THE SQUARE ROOT OF 2 TO 100 DECIMAL PLACES
               CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD     
     *
               ORG  87
     X1        DCW  000                 *INDEX REGISTER 1
               DCW  11                  *IDENTIFING FILLER
     X2        DCW  000                 *INDEX REGISTER 2
               DCW  22                  *IDENTIFING FILLER
     X3        DCW  000                 *INDEX REGISTER 3
               DCW  33                  *IDENTIFING FILLER
     *
     *
               ORG  340                 *ORG JUST PAST THE PRINT BUFFER
               DCW  @COMPUTE SQUARE ROOT 06-24-2009@
     N         DCW  01
               DC   #200               len = 2*dp
     *
     X         DCW  #102               len = len(N) + dp
               DC   #2                 remainder of /2: len = 2
     *
     XPREV     DCW  #102               len = len(X)
     *
     TEMP      DCW  #202               len = len(N) + 2*dp
               DC   #103               remainder of /X: len = len(X) + 1
     ITERS     DCW  000
               DCW  @0.@
               DC   @   &   &   &   &   &   &   &   &   &   &@
               DC   @   &   &   &   &   &   &   &   &   &   &@
               DC   @   &   &   &   &   &   &   &   &   &   &@
     EDIT      DC   @   &   &   & @          len = dp
     *
     START     CS   332             *CLEAR PRINT STORAGE
               CS                   *CLEAR PRINT STORAGE
               MCW  N,225           *PRINT HEADER
               MCW  @THE SQUARE ROOT OF @ *PRINT HEADER
               W                    *PRINT HEADER
               CS   332             *CLEAR PRINT STORAGE
               CS                   *CLEAR PRINT STORAGE
               W                    *PRINT BLANK LINE
     *
     * Newton's algorithm:
     *
     *     x = xprev;
     *     while (x != xprev) {
     *         xprev = x;
     *         x = (x + n/x)/2;
     *     }
     *
     * X = upper half of N
     *
               ZA   N&100,X            +dp
     *
     * Is X = XPREV?
     *
     LOOP      A    @1@,ITERS
               BCE  DONE,ITERS-2,1
     *
     * XPREV = X
     *
               ZA   X,XPREV
     *
     * X = (N/X + X)/2
     *
               ZA   N&200,TEMP&103     +2*dp, +len(N) + dp + 1
               D    X,TEMP-97          +len(N) - dp + 1
               SW   TEMP-102           -(len(N) + dp)
               A    X,TEMP
               ZA   TEMP,X&2           +2
               D    @2@,X-100          -(len(N) + dp) + 2
               CW   TEMP-102           -(len(N) + dp)
     *
     * Print X and loop again.
     *
               LCA  EDIT,339
               MCE  X,339
               C    X-6,XPREV-6
               B    DONE,S             done if yes            
               W
               B    LOOP
     *
     * Print number of iterations.
     *
     DONE      CS   332
               CS
               A    -1,ITERS
               MZ   ITERS-1,ITERS
               MCW  @ ITERATIONS@,218
               MCW  ITERS
               W
               CS   332
               CS
               W
               BCE  DONE2,N,5           *HAVE WE DONE ALL?
               A    @1@,N               *ADD 1 TO N
               MCW  @000@,ITERS
               B    START
     DONE2     CC   1                   *JUMP TO TOP OF PAGE
               NOP  999,999             *PUT 999 IN ADDRESS REGISTER
               H                        *HALT BEFORE GOING TO THE NEXT PROGRAM
               CS   332                 *CLEAR UPPER PRINT BUFFER
               CS                       *CLEAR LOWER PRINT BUFFER
               CS                       *CLEAR PUNCH BUFFER
               CS                       *CLEAR READ BUFFER
               SW   001                 *SET FIRST WM
     MORE      R                        *READ ANOTHER CARD
               BCE  001,001,,           *IF IT IS A COMMA, GO TO THE CODE
               B    MORE                *READ ANOTHER
               NOP                      *TRAILER WITH A WM
               END  START
