               job  tictactoe
     * Play tic-tac-toe
     * Ken Shirriff  http://righto.com
               ctl  6641

               org  087
     X1        dcw  000  * Index 1, switch setting
               org  092
     X2        dcw  000  * Index 2, tree pointer
               org  097
     X3        dcw  000  * Index 3
     
               org  333
     
     switch    dcw  @000@
     chk       dcw  @00@

    
     usergo    dcw  @1@                * User goes first
     you       dcw  @Your move:@
     me        dcw  @My move:@ 
     youwin    dcw  @You win!@
     iwin      dcw  @I win@
     idraw     dcw  @Draw@



     

     board2    dcw  @-!-!-@
               
     intro0    dcw  @0@
               dcw  @Then press Continue Program.@
               dcw  @    !    !    @
               dcw  @ DE ! DF ! DG @
               dcw  @    !    !    @
               dcw  @----!----!----@
               dcw  @ CE ! CF ! CG @
               dcw  @    !    !    @
               dcw  @----!----!----@
               dcw  @ BE ! BF ! BG @
               dcw  @    !    !    @
               dcw  @Flip one of E, F, or G up to select column:@
               dcw  @To move, flip one of B, C, or D up to select row.@
               dcw  @You play X, computer plays O@
               dcw  @Welcome to tic-tac-toe at the computer history @
     intro     dc   @museum!@
     

     data1     dcw  @0@   * Positions 1 through 9
     data2     dcw  @0@
     data3     dcw  @0@
     data4     dcw  @0@
     data5     dcw  @0@
     data6     dcw  @0@
     data7     dcw  @0@
     data8     dcw  @0@
     data9     dcw  @0@
     
               

     
               org  3000
     start     cs   299

           
               mcw  +intro, x1
     wintro    b    write
               c    +intro0, x1
               bu   wintro
     
     init      cs   1
               mcw  @ @, data9         * Clear data                       
               mcw  @ @
               mcw  @ @
               mcw  @ @
               mcw  @ @
               mcw  @ @
               mcw  @ @
               mcw  @ @
               mcw  @ @
               c    @1@, usergo        * Is user going first?
               mcw  @0@, usergo
               be   init1
               mcw  @O@, data5         * Computer starts with center
               cs   299
               mcw  @I start:@, 208
               w
               mcw  @1@, usergo
     init1     b    draw
     

     
     * Main game loop
     loop      b    readsw             * Get switch position

               c    @ @, data1-1+x1    * Is space free?
               be   empty
               cs   299                * User picked occupied space, bad.
               mcw  @occupied@, 212
               w
               b    loop
     empty     mcw  @X@, data1-1+x1    * Put user's X
               b    draw

               b    move               * Get computer's move
               b    puto               * Put O in position amv  
               b    draw

               c    @000@, winmv       * Did computer just have winning move?
               be   loop 
               cs   299
               mcw  iwin, 207
               w
               b    init               * Restart game        




     * Computer move logic. Scan rows, columns, diagonals
     * Move is returned in amv
     move      sbr  movex&3
               mcw  @0@, amv
               mcw  @0@, goodmv
               mcw  @0@, winmv
               mcw  @001@, x1          * First row
               mcw  @001@, x2
               b    scan
               mcw  @004@, x1          * Second row
               b    scan
               mcw  @007@, x1          * Third row
               b    scan
               mcw  @001@, x1          * First column
               mcw  @003@, x2    
               b    scan
               mcw  @002@, x1          * Second column
               b    scan
               mcw  @003@, x1          * Third column
               b    scan
               mcw  @001@, x1          * Diagonal
               mcw  @004@, x2
               b    scan
               mcw  @003@, x1          * Diagonal
               mcw  @002@, x2
               b    scan
               c    @ @, data5         * Center free?
               bu   iswin
               mcw  @5@, amv           * Move to center
               b    movex
     iswin     c    @000@, winmv       * A winning move?
               be   isgood
               mcw  winmv, amv
               b    movex
     isgood    c    @000@, goodmv      * A good move?
               be   isamv
               mcw  goodmv, amv
               b    movex              * Make good move
     isamv     c    @000@, amv         * Any move
               bu   movex

     adraw     cs   299                * A draw
               mcw  idraw, 204
               w
               b    init               * Bail out
      
     movex     b    @000@
     
     * Scan from x1 with increment of x2
     * Count x's in xcnt, o's, in ocnt. blkpos is position of blank if any
     scan      sbr  scanx&3
               mcw  @0@, cnt
               mcw  @0@, ocnt
               mcw  @0@, xcnt
               mcw  @0@, blkpos
     scanl     c    @X@, data1-1&x1     * Scan loop. Count X's
               bu   scan1
               a    +1, xcnt
               b    snext
     scan1     c    @ @, data1-1&x1    * Empty space?
               bu   scan2
               mn   x1, blkpos         * Found a blank
               mn   x1, amv            * A possible move, so remember it
               b    snext
     scan2     c    @o@, data1-1&x1    * Count O's
               bu   snext
               a    +1, ocnt
     snext     a    @1@, cnt             * Move to next
               ma   x2, x1
               c    @3@, cnt
               bu   scanl              * Loop
     
     * Check for win or lose
               mz   @0@, blkpos
               c    @3@, xcnt           * Player's count
               bu   s1
               cs   299
               w
               mcw  youwin, 208        * Player has 3 in a row and wins
               w
               b    init
     s1        c    @2@, ocnt           * Computer's count. 2 in a row?
               bu   s2
               c    @0@, blkpos        * And a blank spot?
               be   s2
               mcw  blkpos, winmv       * remember this winning move
               b    scanx
     s2        c    @2@, xcnt           * Player has two in a row?
               bu   scanx
               c    @0@, blkpos
               be   scanx
               mcw  blkpos, goodmv     * Would be a good move to block it
               
     
     scanx     b    @000@              * return                     

     cnt       dcw  @0@
     xcnt      dcw  @0@
     ocnt      dcw  @0@                
     blkpos    dcw  @0@                * Position of blank
     amv       dcw  @0@                * A move
     goodmv    dcw  @0@                * Good move
     winmv     dcw  @0@                * Winning move

     * Place computer O in spot amv
     puto      sbr  putox&3
               cs   299
               mcw  me, 208
               w

               mcw  amv, x1
               mcw  @O@, data1-1&X1
     putox     b    @000@              * Return
     
     * Writes text from X1 to printer left aligned, using x2 and x3
     write     sbr  writex&3
               cs   299
               mcw  @201@, x2
               mcw  x1, x3
               mcw  x1, 210
     write1    ma   @I9I@, x1    * I9I = -1 for 16K
               ma   @001@, x2
               bwz  write2, 0&x1, 1
               b    write1
     write2    ma   @I9I@, x1    * I9I = -1 for 16K
               mcw  0&x3, 0&x2
               w
     writex    b    @000@

     * Draws board
     draw      sbr  drawx&3
               cs   299
               w
               mcw  board2, 240
               mcw  data1, 236
               mcw  data2, 238
               mcw  data3, 240
               w
               mcw  board2, 240
               w
               mcw  data4, 236
               mcw  data5, 238
               mcw  data6, 240
               w
               mcw  board2, 240
               w
               mcw  data7, 236
               mcw  data8, 238
               mcw  data9, 240
               w
     drawx     b    @000@
     
     * Read switch settings into x1 with value 1-9.
     * Because BSS branches if the switch is set, everything is backwards. 
     * Want B: +0, C: +3, D: +6, E: +0, F: +1, G: +2 
     * Instead subtract if switch is not set, and start with 13
     * For chk, add 4 for a row switch and 1 for a column not set.
     * Should end up with 10. This checks that one of each is set
     readsw    sbr  readsx&3
               cs   299
               w
               mcw  you, 210
               w
     reads1    h
               ZA   +13, x1
               za   +0, chk
               BSS  readb,B
               a    +4,chk
     readb     bss  readc,c
               s    +3,x1 
               a    +4,chk
     readc     bss  readd,d
               s    +6, x1
               a    +4, chk
     readd     bss  reade, e
               a    +1, chk
     reade     bss  readf, f
               s    +1, x1
               a    +1, chk
     readf     bss  readg, g
               s    +2, x1
               a    +1, chk
     readg     mz   @0@, x1
               c    @1?@, chk
     readsx    be   @000@              * Return
               cs   299
               mcw  @can't read switches@, 219
               w
               b    reads1          
    

   

               end  start
